/*
 * Description: Remove a file from page cache
 * Author: Catalin(ux aka Dino) BOIE
 * E-mail: catab at embedromix dot ro
 */

#define __USE_GNU
#define	_GNU_SOURCE
#define __USE_XOPEN2K
#define __USE_LARGEFILE64
#define __USE_FILE_OFFSET64

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <dlfcn.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <dirent.h>
#include <asm/unistd.h>
#include <fcntl.h>


int main(int argc, char *argv[])
{
	int fd, err;

	if (argc < 2) {
		fprintf(stderr, "Usage: noca_file <file>\n");
		return 1;
	}

	fd = open(argv[1], O_RDONLY);
	if (fd == -1) {
		fprintf(stderr, "Error: canno open [%s] (%s)!\n",
			argv[1], strerror(errno));
		return 1;
	}

	err = posix_fadvise(fd, 0, 0, POSIX_FADV_DONTNEED);
	if (err < 0) {
		fprintf(stderr, "Error: Cannot call posiz_fadvise (%s)!\n",
			strerror(errno));
		close(fd);
		return 1;
	}

	close(fd);

	return 0;
}
